/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package clientws;

import clientws.bdsqlserver.FileData;
import clientws.log.ClientScada;
import clientws.log.Log;
import com.pot.ser.Histo;
import com.pot.ser.KoalaWS;
import com.pot.ser.KoalaWS_Service;
import com.pot.ser.SignalLastValue;
import java.math.BigInteger;
import java.net.URL;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collections;
import java.util.Date;
import java.util.List;
import javax.xml.ws.BindingProvider;
import javax.xml.ws.handler.MessageContext;

/**
 *
 * @author jmas
 */
public class MainProces implements Runnable {

    private static MainProces INSTANCE = null;
    private final KoalaWS_Service koalaWS_Service;
    private final KoalaWS port;
    private FileData fileData;
    private List<ClientScada> listClient;

    public static MainProces getInstance() throws Exception {

        if (INSTANCE == null) {
            INSTANCE = new MainProces();
        }

        return INSTANCE;
    }

    private MainProces() throws Exception {
        koalaWS_Service = new KoalaWS_Service(new URL(Parameters.URLWSDL));
        port = koalaWS_Service.getKoalaWSPort();

        listClient = Parameters.getClients();

        
        BindingProvider bp = (BindingProvider) port;
        bp.getRequestContext().put(BindingProvider.SESSION_MAINTAIN_PROPERTY, Boolean.TRUE);
        bp.getRequestContext().put(MessageContext.HTTP_REQUEST_HEADERS, Collections.singletonMap("Content-Type", Collections.singletonList("text/xml")));

        fileData = null;
    } //ClietnWEBService

    @Override
    public void run() {

        Log.info("********** Comença el procés de volcat l aplicatiu YES: " + new Date() + "**********");
        ClientScada clientScada = new ClientScada(null, null, null, null, null, "I585", "perakus", null);
//        for (ClientScada clientScada : listClient) {
            try {
                fileData = new FileData(clientScada);
                Log.info("Identificant instal·lació: ");
                if (identification("I585", "perakus")) {
                    Log.info("Identificació OK");

                    Log.info("Validant taula: ");
                    if (validationTable()){
                        Log.info("Validació taula OK");
                    } else {
                        Log.warn("Validació taula Incorrecte");
                        Log.warn("Generant taula de senyals: ");
                        generateTable();
                        Log.info("Generació taula OK");
                    }
                    Log.info("Ultims valors:");
                    
                    Calendar cal = Calendar.getInstance();
                    
                    List<SignalLastValue> listLastValues = lastValues();
                    for (SignalLastValue signalLastValue : listLastValues) {
                       
                        //Convertim data de la ultima data en human data
                        
                        BigInteger EpochData = signalLastValue.getDatetime();
                        Long DataH = EpochData.longValue();
                        cal.setTimeInMillis(DataH);
                        
                        Log.info("\tÚltim valor del Codi senyal: " + signalLastValue.getCode() + ", " +  cal.getTime() + " UNIX TIME " + signalLastValue.getDatetime() + " " + signalLastValue.getData());
                        List<Histo> listHisto = new ArrayList<Histo>();
                        try {
                            //Aconseguim els historics
                            listHisto = fileData.getSignalHisto(signalLastValue.getCode(), signalLastValue.getDatetime() == null ? null : new Date(signalLastValue.getDatetime().longValue()));
                        } catch (SQLException e) {
                            Log.error("Error obtenint històrics de la senyal");
                            throw (Exception) e;
                        }
                        Log.info("Volcat històrics de la senyal " + signalLastValue.getCode() + ":");
                        dumpValues(signalLastValue.getCode(), listHisto);
                        Log.info("Volcat històrics de la senyal " + signalLastValue.getCode() + " OK");
                    }
                    Log.info("S'ha completat correctament el volcat de dades a l'aplicatiu YES");
                } else {
                    throw new Exception("Error identificació instal·lació");
                }
            } catch (Exception e) {
                Log.error(e.getMessage());
                Log.error("No s'ha pogut completar el volcat de dades a l'aplicatiu YES");
            } finally {
                //con.close();
                Log.info("*****" + "Finalitza el procés: " + new Date() + "*****");
                Log.info("**********************************");
            }
//        }

    }

    private boolean identification(String code, String password) throws Exception {
        boolean ident = false;
        Log.info("\tusuari: " + code);
        Log.info("\tpassword: ******");
        try {
            ident = port.identification(code, password);
        } catch (Exception e) {
            throw new Exception("Identification: " + e.getMessage());
        }

        return ident;
    }

    private boolean validationTable() throws Exception {
        boolean validate = false;
        try {
            validate = port.validationTable(fileData.getSignalsDescription());
        } catch (Exception e) {
            throw new Exception("ValidationTable: " + e.getMessage());
        }
        return validate;
    }

    private void generateTable() throws Exception {
        try {
            port.generateTable(fileData.getSignalsDescription());
        } catch (Exception e) {
            throw new Exception("GenerateTable: " + e.getMessage());
        }
    }

    private List<SignalLastValue> lastValues() throws Exception {
        List<SignalLastValue> list = new ArrayList<SignalLastValue>();

        try {
            list = port.lastValues();
        } catch (Exception e) {
            throw new Exception("LastValues: " + e.getMessage());
        }

        return list;
    }

    private void dumpValues(String code, List<Histo> list) throws Exception {

        try {
            port.dumpValues(code, list);
        } catch (Exception e) {
            throw new Exception("DumpValues: " + e.getMessage());
        }
    }
}
